mapMod = ...

-- --------------------------------------------------------------------------
local COMP_TRACER = {
    TypeName = "AA_COMP_TRACER",
    ParentType = "COMPONENT",
	Properties = {
        { Name = "Prefab", Type = "string" },
    }
}


--------------------------------------------------------------------------
function COMP_TRACER:init()
    local owner = self:getOwner()
    local x = tostring(owner:getGlobalPosition()[1])
    local y = tostring(owner:getGlobalPosition()[2])
    local z = tostring(owner:getGlobalPosition()[3])
    local a = tostring(owner:getGlobalOrientation()[1])
    local b = tostring(owner:getGlobalOrientation()[2])
    local c = tostring(owner:getGlobalOrientation()[3])
    local d = tostring(owner:getGlobalOrientation()[4])
    mapMod:log('{ Prefab = "' .. self.Prefab .. '", Position = { ' .. x .. ", " .. y .. ", " .. z .. '}, Orientation = { ' .. 
        a .. ', ' .. b .. ', ' .. c .. ', ' .. d .. '} },')
end

mapMod:registerClass(COMP_TRACER)
--------------------------------------------------------------------------

-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockA", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_A_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockB", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_B_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockC", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_C_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockD", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_D_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockE", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_E_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockF", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_F_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockG", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_G_PREFAB" })
-- mapMod:registerPrefabComponent("models/snowy_rocks.fbx/Prefab/RockH", { DataType = "AA_COMP_TRACER", Prefab = MOD_NS .. "TV_MAP_SMALL_ROCK_SNOW_H_PREFAB" })

function addRock(name) 
    mapMod:register({
        DataType = "BUILDING_PART",
        Id = MOD_NS .. "TV_MAP_ROCK_" .. name,
        Name = MOD_NS .. "TV_MAP_ROCK_" .. name,
        ConstructionVisual = MOD_NS .. "TV_MAP_SMALL_ROCK_" .. name .. "_PREFAB",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = MOD_NS .. "TV_MAP_SMALL_ROCK_" .. name .. "_PREFAB"
        }
    })
end


addRock("SNOW_A")
addRock("SNOW_B")
addRock("SNOW_C")
addRock("SNOW_D")
addRock("SNOW_E")
addRock("SNOW_F")
addRock("SNOW_G")
addRock("SNOW_H")
addRock("SMALL_A")

mapMod:register({
	DataType = "BUILDING",
	Id = "ALL_ROCKS",
	Name = "ALL_ROCKS",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingType = "MONUMENT",
	BuildingPartSetList = {
        {
            Name = "ROCKS",
            BuildingPartList = {
                MOD_NS .. "TV_MAP_ROCK_SNOW_A", MOD_NS .. "TV_MAP_ROCK_SNOW_B", MOD_NS .. "TV_MAP_ROCK_SNOW_C", MOD_NS .. "TV_MAP_ROCK_SNOW_D",
                MOD_NS .. "TV_MAP_ROCK_SNOW_E", MOD_NS .. "TV_MAP_ROCK_SNOW_F", MOD_NS .. "TV_MAP_ROCK_SNOW_G", MOD_NS .. "TV_MAP_ROCK_SNOW_H",
            }
        },
	},
	IsEditable = true,
	IsClearTrees = true,
})